/*
  ******************************************************************************
  * @file    APP.h
  * @author  PJ
  * @version V1.0.0
  * @date    2021
  * @brief   I2C Slave demo Header file.
  ******************************************************************************
*/
#ifndef __APP_H__
#define __APP_H__

#include "fxx_std.h"

#define SLAVE_ADDRESS    (0xA6)
#define USER_I2C   I2C1
#define BUFFER_LENGTH    (256)

typedef enum
{
    TEST_SLAVE_POLLING,
    TEST_SLAVE_INTERRUPT,
    TEST_SLAVE_DMA,
}enum_TEST_MODE_t;

extern Slave_Comm_TypeDef    g_SlaveComm;

/* Function : I2C_Slave_Test */
void I2C_Slave_Test(enum_TEST_MODE_t fu8_Mode);

#endif
